<?php

function fop2admin_get_config($engine) {
    // Executed on APPLY in FreePBX, we regenerate the fop2buttons if needed
    global $amp_conf, $db, $active_modules;

    $queuechannelString = fop2_set_queuemember_strings();
    $ver = getversion();
    $ver = str_replace(".","",substr($ver,0,4));

    if($ver>25) {
        $qctx="from-queue";
    } else {
        $qctx="from-internal";
    }

    $fopbutton        = fop2_all_freepbx_buttons();
    $botonesdefinidos = fop2_list_botones();

    foreach ($botonesdefinidos as $devname => $datarray) {
        if(!array_key_exists($devname,$fopbutton)) {
            $results = sql("SELECT id,exten FROM fop2buttons WHERE device='$devname'","getRow",DB_FETCHMODE_ASSOC);
            $boton_id_a_borrar  = $results['id'];
            $boton_exten_a_borrar  = $results['exten'];
            fop2_del_button($boton_id_a_borrar,$boton_exten_a_borrar);
        }
    }

    foreach ($fopbutton as $devname => $datarray) {
        $tipocorto = substr($datarray['type'],0,-1);
        if($tipocorto == "extension") {
            $cfstring="CF/".$datarray['exten'];
            //$qchanstr="Local/".$datarray['exten']."@$qctx/n";
            $qchanstr = $queuechannelString[$datarray['exten']];
            $mmbox    = $datarray['mailbox'];
        } else {
            $cfstring="NULL";
            $qchanstr="NULL";
            $mmbox="NULL";
        }
        if(!isset($botonesdefinidos[$devname])) {

            //$full_user_list = core_users_list();
            //foreach($full_user_list as $dev => $datos) {
            //    $freepbxlabel[$datos[0]] = $datos[1];
            //}

            $freepbxlabel=array();
            $freepbxlabel = fop2_all_freepbx_label();

            $results = sql( "REPLACE INTO fop2buttons (type, device, privacy, label, exten, context, mailbox, queuechannel, customastdb) ".
                "VALUES ('$tipocorto', '".$db->escapeSimple($devname)."', '', '".$db->escapeSimple($freepbxlabel[$datarray['exten']]).
                "','".$datarray['exten']."','".$datarray['context']."','".$datarray['mailbox']."','".$db->escapeSimple($qchanstr)."','$cfstring')");

            if(DB::IsError($results)) {
                die($results->getMessage());
            } else {
                $botonesdefinidos[$devname]=1;
            };
        } else {
            if($tipocorto=="extension") {
                $query = "UPDATE fop2buttons SET queuechannel='".$db->escapeSimple($qchanstr)."', mailbox='".$mmbox."' WHERE type='extension' AND exten='".$datarray['exten']."'";
                $results = sql($query);
            }
        }
    }

    $results = $db->getAll("DESC parkinglot", DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        $query = "SELECT if(`defaultlot`='no',concat('PARK/parkinglot_',id),'PARK/default') AS channel,parkext AS exten FROM parkplus";
        $results= sql($query,"getAll",DB_FETCHMODE_ASSOC); 
        if(is_array($results)){
            foreach($results as $result) {
                 $query = "UPDATE fop2buttons SET exten='".$result['exten']."' WHERE type='park' AND device='".$result['channel']."'";
                 $results = sql($query);
            }
        }

    } else {
        $query = "SELECT data FROM parkinglot WHERE keyword='parkext'";
        $results = sql($query,"getRow",DB_FETCHMODE_ASSOC);
        $parkext = $results['data'];

        $query = "SELECT exten FROM fop2buttons WHERE type='park'";
        $results = sql($query,"getRow",DB_FETCHMODE_ASSOC);
        $parkextfop = $results['exten'];

        if($parkext <> $parkextfop) {
            $query = "UPDATE fop2buttons SET exten='$parkext' WHERE type='park' AND exten='$parkextfop'";
            $results = sql($query);
        }
    }

    $allbuttons= fop2_list_buttons();
    $buttonsid = array();
    foreach ($allbuttons as $devname => $datarray) {
        $buttonsid[]=$datarray['id'];
    }

    // Guardo todos los id de mysql en array asociativo
    $sql = "SELECT type,exten,id FROM fop2buttons";
    $results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    foreach ($results as $result) {
        $buttonasid[$result['type']][$result['exten']]=$result['id'];
    }

    $qry = "REPLACE INTO fop2groups values('-1','All Buttons')";
    $results = sql($qry);
    $qry = "REPLACE INTO fop2groups values('-2','All Extensions')";
    $results = sql($qry);
    $qry = "REPLACE INTO fop2groups values('-3','All Queues')";
    $results = sql($qry);
    $qry = "REPLACE INTO fop2groups values('-4','All Conferences')";
    $results = sql($qry);
    $qry = "REPLACE INTO fop2groups values('-5','All Trunks')";
    $results = sql($qry);

    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Buttons'";
    $results = sql($sql);

    // All Extension = -2
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Extensions'";
    $results = sql($sql);
    foreach($buttonasid['extension'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Extensions',$vval)";
        $results = sql($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }
    // All Queues
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Queues'";
    $results = sql($sql);
    foreach($buttonasid['queue'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Queues',$vval)";
        $results = sql($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }
    // All Conferences
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Conferences'";
    $results = sql($sql);
    foreach($buttonasid['conference'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Conferences',$vval)";
        $results = sql($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }
    // All Trunks
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Trunks'";
    $results = sql($sql);
    foreach($buttonasid['trunk'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Trunks',$vval)";
        $results = sql($sql);
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }
    foreach($buttonasid['park'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }
    foreach($buttonasid['ringgroup'] as $kkey=>$vval) {
        $sql = "INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('All Buttons',$vval)";
        $results = sql($sql);
    }

}

function fop2admin_hookGet_config($engine) {
    global $ext, $amp_conf;

    $mode = $amp_conf['AMPEXTENSIONS'];

    $isdnd = featurecodes_getModuleFeatures('donotdisturb');

    $hasdnd       = 0;
    $hasdndoff    = 0;
    $hasdndtoggle = 0;

    foreach($isdnd as $count=>$indidnd) {
        if($indidnd['featurename']=='dnd_on') {
           $hasdnd=1;
        }
        if($indidnd['featurename']=='dnd_off') {
           $hasdndoff=1;
        }
        if($indidnd['featurename']=='dnd_toggle') {
           $hasdndtoggle=1;
        }
    }

    if(count($isdnd)>0) {

        $dnd_ext = featurecodes_getFeatureCode('donotdisturb', 'dnd_on');
        $dnd_ctx='app-dnd-on';

        if($mode=='deviceanduser') {

            if($hasdnd==1) {
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: USER/${AMPUSER},Value: Do not Disturb'));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('DB(fop2state/USER/${AMPUSER})', 'Do not Disturb'));
            }
    
            if($hasdndoff==1) {
                $dnd_ext = featurecodes_getFeatureCode('donotdisturb', 'dnd_off');
                $dnd_ctx='app-dnd-off';
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: USER/${AMPUSER},Value: '));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_dbdel('fop2state/USER/${AMPUSER})'));
            }
    
            if($hasdndtoggle==1) {
                $dnd_ext = featurecodes_getFeatureCode('donotdisturb', 'dnd_toggle');
                $dnd_ctx='app-dnd-toggle';
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('CHAN', '${CUT(CHANNEL,-,1)}'));
          
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_on', new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: USER/${AMPUSER},Value: Do not Disturb'));
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_on', new ext_setvar('DB(fop2state/USER/${AMPUSER})', 'Do not Disturb'));
    
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_off', new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: USER/${AMPUSER},Value: '));
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_off', new ext_dbdel('fop2state/USER/${AMPUSER}'));
            }
 
        } else {

            if($hasdnd==1) {
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: ${CHAN},Value: Do not Disturb'));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('DB(fop2state/${CHAN})', 'Do not Disturb'));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('CHAN', '${CUT(CHANNEL,-,1)}'));
            }
    
            if($hasdndoff==1) {
                $dnd_ext = featurecodes_getFeatureCode('donotdisturb', 'dnd_off');
                $dnd_ctx='app-dnd-off';
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: ${CHAN},Value: '));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_dbdel('fop2state/${CHAN})'));
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('CHAN', '${CUT(CHANNEL,-,1)}'));
            }
    
            if($hasdndtoggle==1) {
                $dnd_ext = featurecodes_getFeatureCode('donotdisturb', 'dnd_toggle');
                $dnd_ctx='app-dnd-toggle';
                $ext->splice($dnd_ctx, $dnd_ext, 1, new ext_setvar('CHAN', '${CUT(CHANNEL,-,1)}'));
          
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_on', new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: ${CHAN},Value: Do not Disturb'));
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_on', new ext_setvar('DB(fop2state/${CHAN})', 'Do not Disturb'));
    
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_off', new ext_userevent('FOP2ASTDB','Family: fop2state,Channel: ${CHAN},Value: '));
                $ext->splice($dnd_ctx, $dnd_ext, 'hook_off', new ext_dbdel('fop2state/${CHAN}'));
            }
        }
    }

    $iscallforward = featurecodes_getModuleFeatures('callforward');
    $hascf=0;
    $hascfoff=0;
    $hascftoggle=0;

    foreach($iscallforward as $count=>$indicf) {
        if($indicf['featurename']=='cfon') {
           $hascf=1;
        }
        if($indicf['featurename']=='cfoff') {
           $hascfoff=1;
        }
        if($indicf['featurename']=='cf_toggle') {
           $hascftoggle=1;
        }
    }

    if(count($iscallforward)>0) {

        if($hascf==1) {
            $cf_ctx='app-cf-on';
            $cf_ext=featurecodes_getFeatureCode('callforward', 'cfon');
            $ext->splice($cf_ctx, $cf_ext, 'hook_1', new ext_setvar('CHAN', '${DB(DEVICE/${fromext}/dial)}'));
            $ext->splice($cf_ctx, $cf_ext, 'hook_1', new ext_userevent('FOP2CUST','Family: astdbcust,Channel: ${CHAN},Value: ${toext}'));
        }

        if($hascfoff==1) {
           $cf_ctx='app-cf-off';
           $cf_ext=featurecodes_getFeatureCode('callforward', 'cfoff');
           $ext->splice($cf_ctx, $cf_ext, 'hook_1', new ext_setvar('CHAN', '${DB(DEVICE/${fromext}/dial)}'));
           $ext->splice($cf_ctx, $cf_ext, 'hook_1', new ext_userevent('FOP2CUST','Family: astdbcust,Channel: ${CHAN},Value: '));
        }

        if($hascftoggle==1) {
           $cf_ctx='app-cf-toggle';
           $cf_ext=featurecodes_getFeatureCode('callforward', 'cf_toggle');
           $ext->splice($cf_ctx, $cf_ext, 'hook_on', new ext_setvar('CHAN', '${DB(DEVICE/${fromext}/dial)}'));
           $ext->splice($cf_ctx, $cf_ext, 'hook_on', new ext_userevent('FOP2CUST','Family: astdbcust,Channel: ${CHAN},Value: ${toext}'));
           $ext->splice($cf_ctx, $cf_ext, 'hook_off', new ext_setvar('CHAN', '${DB(DEVICE/${fromext}/dial)}'));
           $ext->splice($cf_ctx, $cf_ext, 'hook_off', new ext_userevent('FOP2CUST','Family: astdbcust,Channel: ${CHAN},Value: '));
        }
    }

    $ctx='fop2-park';
    $ext->add($ctx,"_X.",'', new ext_setvar('ARRAY(RETURN_EXTENSION,RETURN_CONTEXT,PARKBUTTON)','${CUT(EXTEN,:,1)},${CUT(EXTEN,:,2)},${CUT(EXTEN,:,3)}'));
    $ext->add($ctx,"_X.",'', new ext_gotoif('$["${PARKBUTTON}" = "PARK/default"]', 'dopark'));
    $ext->add($ctx,"_X.",'', new ext_gotoif('$["${PARKBUTTON}" = ""]', 'dopark'));
    $ext->add($ctx,"_X.",'', new ext_setvar('PARKINGLOT','${PARKBUTTON:5}'));
    $ext->add($ctx,"_X.",'dopark', new extension('Park(,${RETURN_CONTEXT},${RETURN_EXTENSION},1,s)'));

}

function fop2_get_defgroup() {
    global $active_modules, $amp_conf, $db;
    $results = sql( "SELECT groups FROM fop2templates WHERE isdefault=1","getRow",DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    $grouparray = explode(",",$results['groups']);
    return $grouparray;
}

function fop2_get_defperm() {
    global $active_modules, $amp_conf, $db;
    $results = sql( "SELECT permissions FROM fop2templates WHERE isdefault=1","getRow",DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    return $results['permissions'];
}

function fop2_get_deftemplate() {
    global $active_modules, $amp_conf, $db;
    $results = sql( "SELECT id FROM fop2templates WHERE isdefault=1","getRow",DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    return $results['id'];
}

function fop2_all_freepbx_label() {
    global $active_modules, $amp_conf, $db;
    if (function_exists("framework_check_extension_usage")) {
        $full_list = framework_check_extension_usage(true,array('queues'=>1,'conferences'=>1,'core'=>1));
    } else {
        $full_list = oldfreepbx_check_extension_usage(true);
    }

    $return = array();

    foreach ($full_list as $key => $value) {
        foreach ($value as $exten => $item) {
            if($key=="featurecodeadmin") continue;
            $description = explode(":",$item['description'],2);
            $return[$exten]=trim($description[1]);
        }
    }

    $tresults = core_trunks_list();
    foreach ($tresults as $tresult) {
        // Trunk Config
        $devname = str_replace('AMP:', '', $tresult[1]);
        $devname = preg_replace('/(.*)\/\$OUTNUM\$(.*)?/','$1',trim($devname));
        $exten = $tresult[0];
        $return[$exten]=$devname;
    }

    $ringgroups = fop2_ringgroups();
    if(count($ringgroups)>0) {
        foreach ($ringgroups as $extension=>$label) {
            $return[$extension]=$label;
        }
    }

    $parkplus = fop2_parkplus();
    if(count($parkplus)>0) {
        foreach ($parkplus as $extension=>$label) {
            $return[$extension]=$label;
        }
    }

    return $return;

}

function fop2_all_freepbx_buttons() {

    global $active_modules, $amp_conf, $db;

    $mydevices = fop2_getDeviceId();

    if (function_exists("framework_check_extension_usage")) {
        $full_list = framework_check_extension_usage(true,array('queues'=>1,'conferences'=>1,'core'=>1));
    } else {
        $full_list = oldfreepbx_check_extension_usage(true);
    }

    $fopdevice   = array();
    $fopmailbox  = array();
    $fopprivacy  = array();
    $foplabel    = array();
    $fopgroup    = array();
    $fopemail    = array();
    $fopqchannel = array();
    $fopochannel = array();
    $fopcustastdb= array();
    $fopspyoption= array();
    $foptags     = array();
    $fopsortorder= array();

    if ($amp_conf['AMPEXTENSIONS'] == "deviceanduser") {
        //users
        $sql = "SELECT extension,concat('USER/',extension) AS dial,";
        $sql.= "if(voicemail='novm','',concat(extension,'@',voicemail)) AS mailbox FROM users ";
        $sql.= "LEFT JOIN devices ON users.extension=devices.id";
    } else {
        // extensions
        $sql = "SELECT extension,if(dial is null,concat('VIRTUAL/',extension),dial) AS dial,";
        $sql.= "if(voicemail='novm','',CONCAT(extension,'@',voicemail)) AS mailbox FROM users ";
        $sql.= "LEFT JOIN devices ON users.extension=devices.id";
    }
    $results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    foreach ($results as $result) {

        if(preg_match("/[,&]/",$result['dial'])) {
            $partes = preg_split("/[,&]/",$result['dial']);
            $result['dial']=$partes[0];
        }

        if(preg_match('/\$OUTNUM\$/',$result['dial'])) {
            $result['dial'] = preg_replace('/(.*)\/\$OUTNUM\$(.*)?/','$1',trim($result['dial']));
        }

        $fopdevice[$result['extension']]=$result['dial'];
        $fopmailbox[$result['extension']]=$result['mailbox'];
    }

    $foplabel = fop2_all_freepbx_label();

    $sql = "SELECT exten,exclude,privacy,label,`group`,email,channel,queuechannel,";
    $sql.= "originatechannel,customastdb,spyoptions,external,tags,sortorder FROM fop2buttons";
    $results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    foreach ($results as $result) {
        $fopprivacy[$result['exten']]   = $result['privacy'];
        $foplabel[$result['exten']]     = $result['label'];
        $fopgroup[$result['exten']]     = $result['group'];
        $fopemail[$result['exten']]     = $result['email'];
        $fopchannel[$result['exten']]   = $result['channel'];
        $fopqchannel[$result['exten']]  = $result['queuechannel'];
        $fopochannel[$result['exten']]  = $result['originatechannel'];
        $fopcustastdb[$result['exten']] = $result['customastdb'];
        $fopspyoption[$result['exten']] = $result['spyoptions'];
        $foptags[$result['exten']]      = $result['tags'];
        $fopsortorder[$result['exten']] = $result['sortorder'];
        $fopexternal[$result['exten']]  = $result['external'];
        $fopexclude[$result['exten']]   = $result['exclude'];
    }

    foreach ($full_list as $key => $value) {
        foreach ($value as $exten => $item) {
            if($key=="featurecodeadmin") continue;

            $description = explode(":",$item['description'],2);
            $devname = "";
            $devtype = "";
            $privacy = "";
            $group   = "";
            $email   = "";
            $qchannel= "";
            $channel = "";
            $ochannel= "";
            $custastdb="";
            $spyoptions="";
            $tags="";
            $sortorder=0;
            $external="";
            $exclude=(isset($fopexclude[$exten])?$fopexclude[$exten]:'0');
            $sortorder=(isset($fopsortorder[$exten])?$fopsortorder[$exten]:'');

            if($key == "conferences") {
                $devname="CONFERENCE/".$exten;
                $devtype="conferences";
                $context="from-internal";
                $mbox='';
            } else if($key == "core") {
                    $devname=$fopdevice[$exten];
                    $mbox=($fopmailbox[$exten]?$fopmailbox[$exten]:'');
                    $privacy=(isset($fopprivacy[$exten])?$fopprivacy[$exten]:'');
                    $group=(isset($fopgroup[$exten])?$fopgroup[$exten]:'');
                    $email=(isset($fopemail[$exten])?$fopemail[$exten]:'');
                    $channel=(isset($fopchannel[$exten])?$fopchannel[$exten]:'');
                    $qchannel=(isset($fopqchannel[$exten])?$fopqchannel[$exten]:'');
                    $ochannel=(isset($fopochannel[$exten])?$fopochannel[$exten]:'');
                    $custastdb=(isset($fopcustastdb[$exten])?$fopcustastdb[$exten]:'');
                    $spyoptions=(isset($fopspyoption[$exten])?$fopspyoption[$exten]:'');
                    $tags=(isset($foptags[$exten])?$foptags[$exten]:'');
                    $external=(isset($fopexternal[$exten])?$fopexternal[$exten]:'');
                    $devtype="extensions";
                    $context="from-internal";
                } else if($key == "queues") {
                    $devname="QUEUE/".$exten;
                    $devtype="queues";
                    $context="ext-queues";
                    $mbox='';
                }
            //$finallabel = (isset($foplabel[$exten])?$foplabel[$exten]:trim($description[1]));
            $finallabel = (isset($foplabel[$exten]))?$foplabel[$exten]:'';
            $myDevId = (isset($mydevices[$devname]))?$mydevices[$devname]:'';

            if($devtype<>"") {
                $fopbutton[$devname] = array('type'=>$devtype,    'exten'=>$exten,  'name'=>$finallabel, 'devid'=>$myDevId,
                    'context'=>$context, 'mailbox'=>$mbox, 'privacy'=>$privacy, 'group'=>$group,
                    'email'=>$email, 'channel'=>$channel, 'queuechannel'=>$qchannel,
                    'originatechannel'=>$ochannel, 'customastdb'=>$custastdb,
                    'spyoptions'=>$spyoptions, 'external' =>$external, 'exclude' => $exclude, 'tags' => $tags, 'sortorder' => $sortorder);
            }
        }
    }

    $tresults = core_trunks_list();
    foreach ($tresults as $tresult) {
        // Trunk Config
        $devname = str_replace('AMP:', '', $tresult[1]);
        $devname = preg_replace('/(.*)\/\$OUTNUM\$(.*)?/','$1',trim($devname));
        $devtype = "trunks";
        $exten = $tresult[0];
        $exclude=(isset($fopexclude[$exten])?$fopexclude[$exten]:'0');
        $myDevId = (isset($mydevices[$devname])?$mydevices[$devname]:'');
        $finallabel = (isset($foplabel[$exten])?$foplabel[$exten]:$devname);
        $privacy=(isset($fopprivacy[$exten])?$fopprivacy[$exten]:'');
        $michannels = (isset($fopemail[$tresult[0]])?$fopemail[$tresult[0]]:'');
        $sortorder=(isset($fopsortorder[$exten])?$fopsortorder[$exten]:'0');
        if(!isset($fopchannel[$exten])) { $fopchannel[$exten]=""; }
        // echo "trunk $exten ".$fopchannel[$exten]."<br>";
        $fopbutton[$devname] = array('type'=>$devtype,'exten'=>$exten,'name'=>$finallabel,'devid'=>$myDevId,
            'context'=>'','mailbox'=>'','privacy'=>$privacy,'group'=>'','email'=>$michannels,
            'channel'=>$fopchannel[$exten],'customastdb'=>$devname,'exclude'=>$exclude, 'sortorder'=>$sortorder);
    }

    if(function_exists("parking_getconfig")) {

        # Standard Park Module

        $results = parking_getconfig();
        $parkingenabled = isset($results['parkingenabled'])?$results['parkingenabled']:'';
        $parkext        = isset($results['parkext'])?$results['parkext']:70;


        $devid='';
        $results = sql("SELECT id,label,exclude,sortorder FROM fop2buttons WHERE type='park' LIMIT 1","getAll",DB_FETCHMODE_ASSOC);

        if(is_array($results)){
            foreach($results as $result) {
                $devid = $result['id'];
                $label = $result['label'];
                $exclude = $result['exclude'];
                $sortorder = $result['sortorder'];
            }
        }
        if(!isset($label)) { $label=""; }

        if($parkingenabled<>'') {
            $fopbutton['PARK/default'] = array('type'=>'parks','exten'=>$parkext,'name'=>$label,'devid'=>$devid,'context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'','exclude'=>$exclude,'sortorder'=>$sortorder);
        } else {
            $fopbutton['PARK/default'] = array('type'=>'parks','exten'=>'700','name'=>$label,'devid'=>$devid,'context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'','exclude'=>$exclude,'sortorder'=>$sortorder);
        }
        
    } else {

        $results = $db->getAll("DESC parkplus", DB_FETCHMODE_ASSOC);
        if(DB::IsError($results)) {
            # No Park Modules, Default to standard parking on 700
            $fopbutton['PARK/default'] = array('type'=>'parks','exten'=>'700','name'=>'Default','devid'=>'PARK/default','context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'', 'exclude'=>$exclude);

        } else {
            
            # Parkplus Module
            $results= sql("SELECT if(`defaultlot`='no',concat('PARK/parkinglot_',id),'PARK/default') AS channel,name AS label,parkext AS exten,IF(`defaultlot`='no',concat('parkedcalls_',id),'parkedcalls') AS context FROM parkplus","getAll",DB_FETCHMODE_ASSOC); 
            if(is_array($results)){
                foreach($results as $result) {
                    $fopbutton[$result['channel']] = array('type'=>'parks','exten'=>$result['exten'],'name'=>$result['label'],'devid'=>$mydevices[$result['channel']],'context'=>$result['context'],'mailbox'=>'','privacy'=>'','group'=>'','exclude'=>$fopexclude[$result['exten']],'sortorder'=>$fopsortorder[$result['exten']]);
                }
            }
        }
    }

    $ringgroups = fop2_ringgroups();
    if(count($ringgroups)>0) {
        $devid=array();
        $results = sql("SELECT id,exten FROM fop2buttons WHERE type='ringgroup'","getAll",DB_FETCHMODE_ASSOC);
        if(is_array($results)){
            foreach($results as $result) {
                $devid[$result['exten']] = $result['id'];
            }
        }

        foreach ($ringgroups as $extension=>$label) {
            $channel = "RINGGROUP/$extension";
            $finallabel = isset($foplabel[$extension])?$foplabel[$extension]:$label;
            $exclude=isset($fopexclude[$extension])?$fopexclude[$extension]:'0';
            $fopbutton[$channel] = array('type'=>'ringgroups','exten'=>$extension,'name'=>$finallabel,'devid'=>$devid[$extension],'context'=>'ext-group', 'exclude'=>$exclude);
        }
    }

    return $fopbutton;
}

function fop2_ringgroups() {
    $ringgroup=array();
    if (function_exists('ringgroups_list')) {
        $res = ringgroups_list(true);
        foreach($res as $key => $ringarray) {
            $ringgroup[$ringarray['grpnum']]=$ringarray['description'];
        }
    }
    return $ringgroup;
}

function fop2_parkplus() {
    global $db;
    $parkplus=array();
    $results = $db->getAll("DESC parkplus", DB_FETCHMODE_ASSOC);
    if(!DB::IsError($results)) {
        $results= sql("SELECT name as label,parkext as exten from parkplus","getAll",DB_FETCHMODE_ASSOC); 
        if(is_array($results)){
            foreach($results as $result) {
                $parkplus[$result['exten']]=$result['label'];
            }
        }
        return $parkplus;
    }
}

function fop2_list_botones() {
    $ret = array();
    $results = sql("SELECT device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result) {
            $ret[$result['device']] = 1;
        }
    }
    return $ret;
}

function fop2_list_buttons() {
    $ret = array();
    $results = sql("SELECT id,type,exten,label FROM fop2buttons ORDER BY type,exten","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result) {
            $ret[] = $result;
        }
    }
    return $ret;
}

function fop2_list_perms() {
    $allowed = array();
    $results = sql("SELECT * FROM fop2permissions ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            // check to see if we have a dept match for the current AMP User.
            if (!isset($results['deptname']) || checkDept($result['deptname'])){
                $allowed[] = $result;
            }
        }
    }
    //if (isset($allowed)) {
    return $allowed;
    //} else {
    //    return null;
    //}
}

function fop2_list_templates() {
    $results = sql("SELECT * FROM fop2templates ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $allowed[] = $result;
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_list_templates_jsobject() {

    $results = sql("SELECT * FROM fop2templates ORDER BY id","getAll",DB_FETCHMODE_ASSOC);
    $finalret="";
    if(is_array($results)){
        foreach($results as $result) {
            $finalret .= "var tempperm_".$result['id']." = [];\n";
            $objperm = preg_split("/,/",$result['permissions']);
            foreach($objperm as $itm) {
                $finalret .= "tempperm_".$result['id'].".push('$itm')\n";
            }

            $objgrp = preg_split("/,/",$result['groups']);
            $finalret .= "var tempgrp_".$result['id']." = [];\n";
            foreach($objgrp as $itm) {
                $finalret .= "tempgrp_".$result['id'].".push('$itm')\n";
            }

            $objgrp = preg_split("/,/",$result['plugins']);
            $finalret .= "var tempplg_".$result['id']." = [];\n";
            foreach($objgrp as $itm) {
                $finalret .= "tempplg_".$result['id'].".push('$itm')\n";
            }
        }
    }
    return $finalret;
}



function fop2_list_users() {
    $results = sql("SELECT * FROM fop2users ORDER BY exten","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            // check to see if we have a dept match for the current AMP User.
            if (!isset($results['deptname']) || checkDept($result['deptname'])){
                // return this item's dialplan destination, and the description
                $allowed[] = $result;
            }
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_get_perm($id){
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2permissions WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function fop2_get_user($id){
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2users WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function fop2_get_template($id){
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2templates WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function fop2_chk_template($name) {
    $results = sql("SELECT id FROM fop2templates WHERE name = '$name'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}


function fop2_chk_user($exten) {
    $results = sql("SELECT id FROM fop2users WHERE exten = '$exten'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}

function fop2_chk_perm($name) {
    $results = sql("SELECT id FROM fop2permissions WHERE name = '$name'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}


function fop2_chk_group($name) {
    $results = sql("SELECT id FROM fop2groups WHERE name = '$exten'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}

function fop2_add_perm($post) {
    extract($post);
    $name = trim(strtolower($name));

    if ( fop2_chk_perm($name) ) {
        echo "<script>javascript:alert(\"" . _("The permission name is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }

    if ( $name=="" ) {
        echo "<script>javascript:alert(\"" . _("The name cannot be empty.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $groups = fop2_list_groups(1);

    foreach ($groups as $d) {
        $groupid[$d['id']]=$d['name'];
    }

    $results = sql("INSERT INTO fop2permissions (name, permissions) VALUES ('$name', '$strperm')");

    if($results==1) {
        foreach($post['includebot'] as $idx=>$chan){
            $gname = $groupid[$chan];
            $results = sql("INSERT INTO fop2PermGroup (name,id_group,name_group) VALUES ('$name', '$chan','$gname')");
        }
    }

    return true;
}


function fop2_add_user($post) {
    extract($post);
    if ( fop2_chk_user($userid) ) {
        echo "<script>javascript:alert(\"" . _("The user number is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }
    $valid_exten = array();
    $results = core_users_list();
    foreach($results as $key=>$val) {
        $valid_exten[]=$val[0];
    }
    if(!in_array($userid,$valid_exten)) {
        echo "<script>javascript:alert(\"" . _("The user number does not exist. Be sure to select a valid extension.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $results = sql("INSERT INTO fop2users (exten, secret, permissions) VALUES ('$userid', '$secret', '$strperm')");

    if($results==1) {
        foreach($post['includebot'] as $idx=>$chan){
            $results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$userid', '".$chan."')");
        }
        //foreach($post['includeplugin'] as $idx=>$chan){
        //    $results = sql("INSERT INTO fop2UserPlugin (exten,id_plugin) VALUES ('$userid', '".$chan."')");
        //}
 
    }
    return true;
}

function fop2_add_template($post) {
    global $db;

    extract($post);
 
    $templatename=trim($templatename);

    if ( fop2_chk_template($templatename) ) {
        echo "<script>javascript:alert(\"" . _("The template name is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }

    if ( $templatename=="" ) {
        echo "<script>javascript:alert(\"" . _("The name cannot be empty.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }
    $mygroups = array();
    if(isset($post['includebot'])) {
        foreach($post['includebot'] as $idx=>$chan){
            $mygroups[] = $chan;
        }
    }
    $strgroup = implode(",",$mygroups);

    $myplugs = array();
    if(isset($post['includeplug'])) {
        foreach($post['includeplug'] as $idx=>$chan){
            $myplugs[] = $chan;
        }
    }
    $strplug = implode(",",$myplugs);
    $strplug = $db->escapeSimple($strplug);

    if(isset($makedefault)) {
        $mydef = 1;
        $results = sql("UPDATE fop2templates SET isdefault=0");
    } else {
        $mydef = 0;
    }
    $results = sql("INSERT INTO fop2templates (name, permissions, groups, isdefault) VALUES ('$templatename', '$strperm', '$strgroup','$mydef')");
    return true;
}


function fop2_getDeviceId() {
    $myreturn = array();
    $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $myreturn[$result['device']]=$result['id'];
        }
        return $myreturn;
    }
}

function fop2_get_perm_groups($name) {
    $ret = array();
    $results = sql("SELECT id_group FROM fop2PermGroup WHERE name='$name'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_group'];
        }
        return $ret;
    } else {
        return "";
    }
}


function fop2_get_user_groups($exten) {
    $exten = preg_replace('/[^\d]/','',$exten);
    $ret = array();
    $results = sql("SELECT id_group FROM fop2UserGroup WHERE exten='$exten'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_group'];
        }
        return $ret;
    } else {
        return "";
    }
}

function fop2_get_user_plugins($exten) {
    $exten = preg_replace('/[^\d]/','',$exten);
    $ret = array();
    $results = sql("SELECT id_plugin FROM fop2UserPlugin WHERE exten='$exten'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_plugin'];
        }
        return $ret;
    } else {
        return "";
    }
}

function fop2_del_perm($id) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_perm($id);
    $name = $thisItem['name'];
    $results = sql("DELETE FROM fop2PermGroup WHERE name = '$name'","query");
    $results = sql("DELETE FROM fop2permissions WHERE id = '$id'","query");

    $results = sql("SELECT id,permissions FROM fop2users WHERE permissions like '%$name%'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $perms) {
            $ret = array();
            $myid = $perms['id'];
            $mype = $perms['permissions'];
            $partperm = explode(",",$mype);
            foreach($partperm as $itemperm) {
                if($itemperm<>$name) {
                    $ret[] = $itemperm;
                }
            }
            $retstring = implode(",",$ret);
            $query = "UPDATE fop2users SET permissions='$retstring' WHERE id='$myid'";
            $results2 = sql($query);
        }
    }

    // Borramos custom permisos de template
    $results = sql("SELECT * FROM fop2templates WHERE permissions LIKE '%$name%'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $permitstring = preg_split("/,/",$result['permissions']);
            $finalperm = array();
            foreach($permitstring as $itemperm) {
                if($itemperm<>$name) {
                    $finalperm[]=$itemperm;
                }
            }
            $finalpermstring = implode(",",$finalperm);
            sql("UPDATE fop2templates SET permissions='$finalpermstring' WHERE id='".$result['id']."'","query");
        }
    }

}

function fop2_delete_template($id) {
    $id = preg_replace('/[^\d]/','',$id);
    $results = sql("DELETE FROM fop2templates WHERE id = '$id'","query");
}


function fop2_del_user($id) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_user($id);
    $exten = $thisItem['exten'];
    $results = sql("DELETE FROM fop2UserGroup WHERE exten = '$exten'","query");
    //$results = sql("DELETE FROM fop2UserPlugin WHERE exten = '$exten'","query");
    $results = sql("DELETE FROM fop2users WHERE id = '$id'","query");
}

function fop2_buttonsrefresh($post) {
    global $db;
    $full_list = fop2_all_freepbx_label();
    //$full_list = core_users_list();
    foreach($full_list as $exten => $label) {
        //$exten = $datos[0];
        $label = $db->escapeSimple($label);
        $query="UPDATE fop2buttons SET label='$label' WHERE exten='$exten'";
        $results = sql($query,"query");
    }
}

function fop2_fieldedit($post) {
    global $db;
    $partes = split("_",$post['field']);
    $field = $partes[0];
    $id    = $partes[1];
    $val   = $db->escapeSimple($post['value']);
    if($field<>"name" && $field<>"privacy" && $field<>"channel" && $field<>"group" && $field<>"email" && $field<>'queuechannel' && $field<>'originatechannel' && $field<>'customastdb' && $field<>'spyoptions' && $field<>'external' && $field<>'excludebot' && $field<>'tags') { die($field); }
    if($field=="name") $field="label";
    if($field=="excludebot") $field="exclude";
    $results = sql("UPDATE fop2buttons SET `$field`='$val' WHERE id='$id'","query");
    return $results;
}

function fop2_buttonsedit($post) {
    global $db;

    $exclude=array();
    foreach($post as $key=>$val) {
        if(ereg("_",$key)) {
            $partes = split("_",$key);
            $field = $partes[0];
            $id    = $partes[1];
            $exclude[$id]=0;
        }
    }
    foreach($post as $key=>$val) {
        if(ereg("_",$key)) {
            $partes = split("_",$key);
            $field = $partes[0];
            $id    = $partes[1];
            $val   = $db->escapeSimple($val);
            if($field<>"name" && $field<>"privacy" && $field<>"channel" && $field<>"group" && $field<>"email" && $field<>'queuechannel' && $field<>'originatechannel' && $field<>'customastdb' && $field<>'spyoptions' && $field<>'external' && $field<>'excludebot' && $field<>'tags') { die($field); }
            if($field=="name") $field="label";
            if($field=="excludebot") {
                $exclude[$id]=1;
            } else {
                $results = sql("UPDATE fop2buttons SET `$field`='$val' WHERE id='$id'","query");
            }
        }
    }
    foreach($exclude as $id=>$val) {
        $results = sql("UPDATE fop2buttons SET exclude='$val' WHERE id='$id'","query");
    }
}

function fop2_edit_perm($id, $post) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_perm($id);
    $name = $thisItem['name'];

    extract($post);

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $results = sql("UPDATE fop2permissions SET permissions='$strperm' WHERE id = '$id'");

    $results = sql("DELETE FROM fop2PermGroup WHERE name = '$name'","query");

    $groups = fop2_list_groups(1);
    foreach ($groups as $d) {
        $groupid[$d['id']]=$d['name'];
    }

    if(isset($post['includebot'])) {
        foreach($post['includebot'] as $idx=>$chan){
            $gname = $groupid[$chan];
            $results = sql("INSERT INTO fop2PermGroup (name,id_group,name_group) VALUES ('$name', '$chan','$gname')");
        }
    }
    return true;
}

function fop2_edit_template($id, $post) {
    global $db;
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_template($id);
    $name = $thisItem['name'];

    extract($post);

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }
    $mygroups = array();
    if(isset($post['includebot'])) {
        foreach($post['includebot'] as $idx=>$chan){
            $mygroups[] = $chan;
        }
    }
    $strgroup = implode(",",$mygroups);

    $myplugs = array();
    if(isset($post['includeplug'])) {
        foreach($post['includeplug'] as $idx=>$chan){
            $myplugs[] = $chan;
        }
    }
    $strplug = implode(",",$myplugs);
    $strplug = $db->escapeSimple($strplug);

    if(isset($makedefault)) {
        $mydef = 1;
        $results = sql("UPDATE fop2templates SET isdefault=0");
    } else {
        $mydef = 0;
    }

    $results = sql("UPDATE fop2templates SET groups = '$strgroup', permissions='$strperm', isdefault='$mydef' WHERE id = '$id'");

    return true;
}


function fop2_edit_user($id, $post) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_user($id);
    $exten = $thisItem['exten'];

    extract($post);

    if (!isset($needconf))
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $results = sql("UPDATE fop2users SET secret = '$secret', permissions='$strperm' WHERE id = '$id'");

    $results = sql("DELETE FROM fop2UserGroup WHERE exten = '$exten'","query");
    //$results = sql("DELETE FROM fop2UserPlugin WHERE exten = '$exten'","query");

    if(isset($post['includebot'])) {
        foreach($post['includebot'] as $idx=>$chan){
            $results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$exten', '$chan')");
        }
    }
    //if(isset($post['includeplugin'])) {
    //    foreach($post['includeplugin'] as $idx=>$chan){
    //        $results = sql("INSERT INTO fop2UserPlugin (exten,id_plugin) VALUES ('$exten', '$chan')");
    //    }
    //}
 
    return true;
}

function fop2_getlastid() {
    $valid_exten = array();
    $results = core_users_list();
    foreach($results as $key=>$val) {
        $valid_exten[]=$val[0];
    }
    asort($valid_exten);

    $existent_exten = array();
    $results = sql("SELECT exten FROM fop2users","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $existent_exten[]=$result['exten'];
        }
    }
    $disponibles = array_diff($valid_exten,$existent_exten);
    asort($disponibles);


    $proximodisponible = array_shift($disponibles);

    return $proximodisponible;
}

function oldfreepbx_check_extension_usage($exten=true, $module_hash=false) {
    global $active_modules;
    $exten_usage = array();

    if (!is_array($module_hash)) {
        $module_hash = $active_modules;
    }

    if (!is_array($exten) && $exten !== true) {
        $exten = array($exten);
    }
    foreach(array_keys($module_hash) as $mod) {
        $function = $mod."_check_extensions_oldfreepbx";
        if (function_exists($function)) {
            $prev_domain = textdomain(NULL);
            if (isset($_COOKIE['lang']) && is_dir("./modules/$mod/i18n/".$_COOKIE['lang'])) {
                bindtextdomain($mod,"./modules/$mod/i18n");
                bind_textdomain_codeset($mod, 'utf8');
                textdomain($mod);
                $module_usage = $function($exten);
            } else {
                textdomain('amp');
                $module_usage = $function($exten);
            }
            if (!empty($module_usage)) {
                $exten_usage[$mod] = $module_usage;
            }
            textdomain($prev_domain);
        }
    }
    if ($exten === true) {
        return $exten_usage;
    } else {
        foreach (array_keys($exten_usage) as $mod) {
            foreach ($exten as $test_exten) {
                if (isset($exten_usage[$mod][$test_exten])) {
                    $exten_matches[$mod][$test_exten] = $exten_usage[$mod][$test_exten];
                }
            }
        }
    }
    return $exten_matches;
}

function core_check_extensions_oldfreepbx($exten=true) {
    global $amp_conf;

    $extenlist = array();
    if (is_array($exten) && empty($exten)) {
        return $extenlist;
    }
    $sql = "SELECT extension, name FROM users ";
    if (is_array($exten)) {
        $sql .= "WHERE extension in ('".implode("','",$exten)."')";
    }
    $sql .= " ORDER BY extension";
    $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

    foreach ($results as $result) {
        $thisexten = $result['extension'];
        $extenlist[$thisexten]['description'] = _("User Extension: ").$result['name'];
        $extenlist[$thisexten]['status'] = 'INUSE';
        $display = ($amp_conf['AMPEXTENSIONS'] == "deviceanduser")?'users':'extensions';
        $extenlist[$thisexten]['edit_url'] = "config.php?type=setup&display=$display&extdisplay=".urlencode($thisexten)."&skip=0";
    }
    return $extenlist;
}

function conferences_check_extensions_oldfreepbx($exten=true) {
    $extenlist = array();
    if (is_array($exten) && empty($exten)) {
        return $extenlist;
    }
    $sql = "SELECT exten, description FROM meetme ";
    if (is_array($exten)) {
        $sql .= "WHERE exten in ('".implode("','",$exten)."')";
    }
    $sql .= " ORDER BY exten";
    $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

    foreach ($results as $result) {
        $thisexten = $result['exten'];
        $extenlist[$thisexten]['description'] = _("Conference: ").$result['description'];
        $extenlist[$thisexten]['status'] = 'INUSE';
        $extenlist[$thisexten]['edit_url'] = 'config.php?display=conferences&extdisplay='.urlencode($thisexten);
    }
    return $extenlist;
}

function queues_check_extensions_oldfreepbx($exten=true) {
    global $active_modules;

    $extenlist = array();
    if (is_array($exten) && empty($exten)) {
        return $extenlist;
    }
    $sql = "SELECT extension, descr FROM extensions WHERE application='Queue' ";
    if (is_array($exten)) {
        $sql .= "AND extension in ('".implode("','",$exten)."')";
    }
    $sql .= " ORDER BY extension";
    $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

    //$type = isset($active_modules['queues']['type'])?$active_modules['queues']['type']:'setup';
    foreach ($results as $result) {
        $thisexten = $result['extension'];
        $extenlist[$thisexten]['description'] = sprintf(_("Queue: %s"),$result['descr']);
        $extenlist[$thisexten]['status'] = _('INUSE');
        $extenlist[$thisexten]['edit_url'] = 'config.php?display=queues&extdisplay='.urlencode($thisexten);
    }

    return $extenlist;
}

function fop2_add_group($post) {

    global $db;
    extract($post);

    $name = trim(mysql_real_escape_string($name));

    if ( fop2_chk_group($name) ) {
        echo "<script>javascript:alert(\"" . _("The group name is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }

    if ( $name =='' ) {
        echo "<script>javascript:alert(\"" . _("The name cannot be empty.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf))
        $needconf = '';

    $results = sql("INSERT INTO fop2groups (name) VALUES ('$name')");

    if($results==1) {
        $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
        if(is_array($results)){
            foreach($results as $result){
                $butid[$result['device']]=$result['id'];
            }
        }

        foreach($post['includebot'] as $idx=>$chan){
            $results = sql("INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('$name', '".$butid[$chan]."')");
        }
    }

    return true;
}

function fop2_get_group($id) {
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2groups WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function  fop2_del_button($id,$exten) {
    $id = preg_replace('/[^\d]/','',$id);
    if($exten<>"") {
        $results = sql("DELETE FROM fop2UserGroup WHERE exten = '$exten'","query");
        //$results = sql("DELETE FROM fop2UserPlugin WHERE exten = '$exten'","query");
        $results = sql("DELETE FROM fop2users WHERE exten = '$exten'","query");
    }
    $results = sql("DELETE FROM fop2GroupButton WHERE id_button = '$id'","query");
    $results = sql("DELETE FROM fop2buttons WHERE id = '$id'","query");
    return true;
}

function  fop2_del_group($id) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_group($id);
    $name = $thisItem['name'];
    $results = sql("DELETE FROM fop2GroupButton WHERE group_name = '$name'","query");
    $results = sql("DELETE FROM fop2groups WHERE id = '$id'","query");
    $results = sql("DELETE FROM fop2UserGroup WHERE id_group = '$id'","query");

    // Borramos grupo de template
    $results = sql("SELECT * FROM fop2templates WHERE groups LIKE '%$name%'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $grupejos = preg_split("/,/",$result['groups']);
            $finalgrp = array();
            foreach($grupejos as $itemgroup) {
                if($itemgroup<>$name) {
                    $finalgrp[]=$itemgroup;
                }
            }
            $finalgroupstring = implode(",",$finalgrp);
            sql("UPDATE fop2templates SET groups='$finalgroupstring' WHERE id='".$result['id']."'","query");
        }
    }
    return true;
}

function fop2_edit_group($id,$post) {
    $id = preg_replace('/[^\d]/','',$id);
    $thisItem = fop2_get_group($id);
    $name = $thisItem['name'];

    extract($post);

    if (!isset($needconf))
        $needconf = '';

    $results = sql("DELETE FROM fop2GroupButton WHERE group_name = '$name'","query");
    $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $butid[$result['device']]=$result['id'];
        }
    }

    foreach($post['includebot'] as $idx=>$chan){
        $results = sql("INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('$name', '".$butid[$chan]."')");
    }

    return true;
}

function fop2_list_groups($all) {
    if($all==1) {
        $results = sql("SELECT * FROM fop2groups WHERE id>=-9 ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    } else {
        $results = sql("SELECT * FROM fop2groups WHERE id>=0 ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    }
    if(is_array($results)){
        foreach($results as $result){
            $allowed[] = $result;
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_list_plugins() {
    $results = sql("SELECT * FROM fop2plugins ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $allowed[] = $result;
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_get_group_buttons($name) {
    $ret = array();
    $results = sql("SELECT id_button FROM fop2GroupButton WHERE group_name='$name'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_button'];
        }
        return $ret;
    } else {
        return "";
    }
}

function fop2_set_queuemember_strings() {

    global $db, $astman;

    $ver = getversion();
    $ver = str_replace(".","",substr($ver,0,4));

    if($ver>25) {
        $qctx="from-queue";
    } else {
        $qctx="from-internal";
    }

    $restrictqueue = array();
    $membname      = array();
    $devices       = array();
    $queuemember   = array();

    $myexten       = core_users_list();

    $pepe = fop2_all_freepbx_buttons();
    foreach($pepe as $mdevice=>$darray) {
        if($darray['type']='extensions') {
            $devForExten[$darray['exten']]=$mdevice;
        }
    }
    unset($pepe);

    foreach($myexten as $cnt=>$datarray) {
        $membname[$datarray[0]]=$datarray[1];
    }

    $engineinfo = engine_getinfo();
    $astver =  $engineinfo['version'];
    $ast_ge_14_25 = version_compare($astver,'1.4.25','ge');
    if($ast_ge_14_25) {
        $device_results = core_devices_list('all','full',true);
        if (is_array($device_results)) {
            foreach ($device_results as $device) {
                if (!isset($devices[$device['user']]) && $device['devicetype'] == 'fixed') {

                    if(preg_match("/[,&]/",$device['dial'])) {
                        $partes = preg_split("/[,&]/",$device['dial']);
                        $device['dial']=$partes[0];
                    }

                    if(preg_match('/\$OUTNUM\$/',$device['dial'])) {
                        $device['dial'] = preg_replace('/(.*)\/\$OUTNUM\$(.*)?/','$1',trim($device['dial']));
                    }

                    $devices[$device['user']] = $device['dial'];
                }
            }
            unset($device_results);
        }
    }

    $wasstatic = array();
    $results = queues_list(true);
    // We traverse all queue config and we end up with strings for static/dynamic defined agents
    // but with no data for non configured extensions.
    foreach($results as $result) {
        $cola = $result[0];
        $results2 = queues_get($cola, true);
        foreach($results2['member'] as $key=>$val) {
            $partes = preg_split("/\//",$val);
            $pertas = preg_split("/\D/",$partes[1]);
            $extension_number = $pertas[0];
            if(!isset($devices[$extension_number])) { $devices[$extension_number]=""; }
            $pirtas = preg_split("/,/",$val);
            $queuemember[$cola][$extension_number]=$pirtas[0]."|Penalty=".$pirtas[1]."|MemberName=".$membname[$extension_number];
            if(isset($devices[$extension_number])) {
                if($devices[$extension_number] <> "") {
                    $queuemember[$cola][$extension_number].="|StateInterface=".$devices[$extension_number];
                    $wasstatic[$extension_number]=1;
                }
            }
        }
        $mem=array();
        if ($astman) {
            $dynmemberonly = strtolower($astman->database_get('QPENALTY/'.$cola,'dynmemberonly'));
            $get=$astman->database_show('QPENALTY/'.$cola.'/agents');
            foreach($get as $key => $value){
                $key=explode('/',$key);
                $mem[$key[4]]=$value;
            }
            foreach($mem as $mem => $pnlty){
                if(!isset($devices[$mem])) { $devices[$mem]=""; }
                $queuemember[$cola][$mem]="Local/".$mem."@".$qctx."/n|Penalty=$pnlty|MemberName=".$membname[$mem];
                if(isset($devices[$mem])) {
                    if($devices[$mem]<>"") {
                        $queuemember[$cola][$mem].="|StateInterface=".$devices[$mem];
                    }
                }
                if($dynmemberonly=="yes") {
                    $restrictqueue[$cola][]=$devForExten[$mem];
                }
            }
        }
    }

    // Here we populate the string for extensions that are not defined as static members, for default values
    foreach($membname as $exten=>$name) {
        if(!isset($wasstatic[$exten])) {
            $pipo = "Local/$exten"."@".$qctx."/n|Penalty=0|MemberName=".$name;
            if(isset($devices[$exten])) {
                if($devices[$exten]<>"") {
                    $pipo.="|StateInterface=".$devices[$exten]."&";
                }
            }
            $memberline[$exten]=$pipo;
        } else {
            $memberline[$exten]="";
        }
    }

    if(count($queuemember)>0) {
        foreach($queuemember as $cola => $datarray) {
            foreach($datarray as $exten => $stringmember) {
                if(isset($memberline[$exten])) {
                    $memberline[$exten].=$stringmember."|Queue=$cola"."&";
                }
            }
        }
    }

    foreach($memberline as $exten => $linea) {
        if(substr($linea,-1,1)=="&") {
            $linea = substr($linea,0,-1);
        }
        $memberline[$exten]=$linea;
    }

    $restrictstring="";
    foreach($restrictqueue as $cola=>$datarray) {
        $restrictstring .= "restrictqueue=QUEUE/$cola:".implode(",",$datarray)."\\n";
    }

    $query = "REPLACE INTO fop2settings (keyword,value) VALUES ('restrictqueue','$restrictstring')";
    sql($query);

    return $memberline;
}
 
function fop2SetButtonOrder($vars) {
    foreach($vars['listitem'] as $orden=>$exten) {
        $exten = preg_replace("/^trunkout/","OUT_",$exten);
        $query="UPDATE fop2buttons SET sortorder='$orden' WHERE exten='$exten'";
        sql($query);
    }
}

function getFastestMirror() {
   $mirror = array();
   $mirror[]="download.fop2.com";
   $mirror[]="download2.fop2.com";
   $mirror[]="download3.fop2.com";
   $faster = 1000;
   $use = $mirror[0];
   foreach($mirror as $host) {
      $result = ping($host,1);
      if($result<$faster) { $use = $host; $faster=$result; }
   }
   return $use;
}

function getOnlinePlugins($mirror) {
    $return = array();
    $fn = "http://$mirror/plugins/plugins.xml";
    ini_set('user_agent','Wget/1.10.2 (Red Hat modified)');
    $available_online = @ file_get_contents($fn);
    $xml = new xml2Array($available_online);
    $xmlarray = $xml->parseAdvanced($available_online);
    return $xmlarray['plugins']['plugin'];
}

function getGlobalPlugins() {
    $ret = array();
    $results = sql("SELECT rawname FROM fop2plugins WHERE global=1","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[$cols['rawname']]=1;
        }
    } 
    return $ret;
}

function getInstalledPlugins() {
    global $amp_conf;
    $results = array();
    if ($handle = opendir($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/')) {
        while (false !== ($entry = readdir($handle))) {
            if ($entry != "." && $entry != "..") {
                if(is_dir($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'.$entry)) {
                     $data = file_get_contents($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'.$entry.'/plugin.xml');
                     $xml = new xml2Array($data);
                     $xmlarray = $xml->parseAdvanced($data);
                     $results[$xmlarray['plugin']['rawname']]=$xmlarray['plugin']['version'];
                }
            }
        }
        closedir($handle);
    }
    return $results;
}

function getParamsForPlugin($rawname) {
    global $amp_conf;
    if(is_readable($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'.$rawname.'/plugin.xml')) {
        $data = file_get_contents($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'.$rawname.'/plugin.xml');
        $xml = new xml2Array($data);
        $xmlarray = $xml->parseAdvanced($data);
    }
    return $xmlarray['plugin']['params'];
}

function fop2_rrmdir($dir) {

    if(!preg_match('/\/fop2admin\/plugins/',$dir)) { die(); }

    foreach(glob($dir . '/*') as $file) {
        if(is_dir($file)) { fop2_rrmdir($file); } else { unlink($file); }; 
    }
    rmdir($dir); 
}

function plugin_handleupload($uploaded_file) {
        global $amp_conf;
        $errors = array();
        
        if (!isset($uploaded_file['tmp_name']) || !file_exists($uploaded_file['tmp_name'])) {
                $errors[] = _("Error finding uploaded file - check your PHP and/or web server configuration");
                return $errors;
        }
        
        if (!preg_match('/\.(tar\.gz|tgz)$/', $uploaded_file['name'])) {
                $errors[] = _("File must be in tar+gzip (.tgz or .tar.gz) format");
                return $errors;
        }
        
        if (!preg_match('/^([A-Za-z][A-Za-z0-9_]+)\-([0-9a-zA-Z]+(\.[0-9a-zA-Z]+)*)\.(tar\.gz|tgz)$/', $uploaded_file['name'], $matches)) {
                $errors[] = _("Filename not in correct format: must be pluginname-version.tar.gz (eg. customplugin-0.1.tar.gz)");
                return $errors;
        } else {
                $pluginname = $matches[1];
                $pluginversion = $matches[2];
        }
        
        $temppath = $amp_conf['AMPWEBROOT'].'/admin/modules/_cache/'.uniqid("upload");
        if (! @mkdir($temppath) ) {
                return array(sprintf(_("Error creating temporary directory: %s"), $temppath));
        }
        $filename = $temppath.'/'.$uploaded_file['name'];
        
        move_uploaded_file($uploaded_file['tmp_name'], $filename);
        
        exec("tar ztf ".escapeshellarg($filename), $output, $exitcode);
        if ($exitcode != 0) {
                $errors[] = _("Error untaring uploaded file. Must be a tar+gzip file");
                return $errors;
        }
        foreach ($output as $line) {
                // make sure all lines start with "pluginname/"
                if (!preg_match('/^'.$pluginname.'\//', $line)) {
                        $errors[] = 'File extracting to invalid location: '.$line;
                }
        }
        if (count($errors)) {
                return $errors;
        }

        /* We will explode the tarball in the cache directory and then once successful, remove the old plugin before before
         * moving the new one over. This way, things like removed files end up being removed instead of laying around
         *
         * TODO: save old plugin being replaced, if there is an old one.
         *
         */
        exec("rm -rf ".$amp_conf['AMPWEBROOT']."/admin/modules/_cache/$pluginname", $output, $exitcode);
        if ($exitcode != 0) {
                return array(sprintf(_('Could not remove %s to install new version'), $amp_conf['AMPWEBROOT'].'/admin/modules/_cache/'.$pluginnam));
        }
        exec("tar zxf ".escapeshellarg($filename)." -C ".escapeshellarg($amp_conf['AMPWEBROOT'].'/admin/modules/_cache/'), $output, $exitcode);
        if ($exitcode != 0) {
                return array(sprintf(_('Could not untar %s to %s'), $filename, $amp_conf['AMPWEBROOT'].'/admin/modules/_cache'));
        }
        exec("rm -rf ".$amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$pluginname", $output, $exitcode);
        if ($exitcode != 0) {
                return array(sprintf(_('Could not remove old plugin %s to install new version'), $amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'.$pluginname));
        }
        exec("mv ".$amp_conf['AMPWEBROOT']."/admin/modules/_cache/$pluginname ".$amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$pluginname", $output, $exitcode);
        if ($exitcode != 0) {
            return array(sprintf(_('Could not move %s to %s'), $amp_conf['AMPWEBROOT']."/admin/modules/_cache/$pluginname", $amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'));
        }

    return true;
}

function getPlugins() {
    $timeout   = 5;
    $host      = "localhost";
    $context   = "GENERAL";
    $port      = "4445";
    $dati      = "";

    $sk=fsockopen($host,$port,$errnum,$errstr,$timeout) ;
    if (!is_resource($sk)) {
        return 0;
    } else {
        fputs($sk, "<msg data=\"$context|plugins|0|0\" />\0");
        stream_set_timeout($sk, 2);
        $dati.=fgets ($sk, 2048);
    }
    fclose($sk);
    $dati=preg_replace("/{.*}/","",$dati);
    $dati=preg_replace("/[^a-zA-Z,]/","",$dati);
    return $dati;
}

function fop2_print_config_form($rawname) {
    global $amp_conf;
    $inifile = $amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname/$rawname.ini";
    if(file_exists($inifile)) {
        $ini_array = parse_ini_file($inifile, true);
    } else {
        $ini_array = array();
    }
 //              print_r($ini_array);
    $multiform=array();
    $multiform_type=array();
    $ret="<h3>"._('Settings')."</h3><form id='plugin_$rawname'>\n";
    $allpars = getParamsForPlugin($rawname);

    $ret.="<fieldset style='width:400px; margin-bottom:1em; display:none;' id='form-$rawname-skeleton'>";
    $ret.="<legend><span id='legend-".$rawname."-skeleton'></span></legend>";
    $convertToArray=0;
    foreach ( $allpars['param'] as $key=>$param ) {
        if(!is_array($param)) {
           $convertToArray=1;
           break;
        }
    }
    if($convertToArray==1) {
        $tempA = $allpars['param'];
        $allpars['param']=Array();
        $allpars['param'][]=$tempA;
    }
    foreach ( $allpars['param'] as $key=>$param ) {
       $formname = $param['name'];
       $formtype = $param['type'];
       $formdefault = $param['default'];
       $formmulti = $param['multi'];
       $fftype=array();
       $fftype['string']='text';
       $fftype['integer']='number';
       $ret.="<label style='width:150px; float:left;' for='$rawname-".$formname."-default'>$formname: </label><input type='".$fftype[$formtype]."' name='$rawname-".$formname."-default' id='$rawname-".$formname."-default' value='".$formdefault."' class='xeditable'><br/>\n";
    }
    $ret.="<button id='removesection-$rawname-skeleton' onClick='fop2_removeSection(this.id); return false;'>"._('Remove Section')."</button>\n";
    $ret.="</fieldset>\n";

    $ret.="<fieldset style='width:400px; margin-bottom:1em;' id='form-$rawname-default'>";
    foreach ( $allpars['param'] as $key=>$param ) {
       $formname = $param['name'];
       $formtype = $param['type'];
       $formdefault = $param['default'];
       $formmulti = $param['multi'];
       $fftype=array();
       $fftype['string']='text';
       $fftype['integer']='number';
       $formval = (isset($ini_array[$formname]))?$ini_array[$formname]:$formdefault;
       $ret.="<label style='width:150px; float:left;' for='$rawname-".$formname."-default'>$formname: </label><input type='".$fftype[$formtype]."' name='$rawname-".$formname."-default' id='$rawname-".$formname."-default' value='".$formval."' class='xeditable'><br/>\n";
       if($formmulti=='yes') {
           $multiform[$formname]=$formdefault;
           $multiform_type[$formname]=$formtype;
       }
    }
    $ret.="</fieldset>\n";

    foreach($ini_array as $section=>$val) {
        if(is_array($val)) {
            $ret.="<fieldset style='width:400px; margin-bottom:1em;' id='form-$rawname-$section'><legend>$section</legend>";
            foreach($multiform as $formname=>$formdefault) {
                $formtype = $multiform_type[$formname];
                $formval = (isset($ini_array[$section][$formname]))?$ini_array[$section][$formname]:$formdefault;
                $ret.="<label style='width:150px; float:left;' for='$rawname-".$formname."-$section'>$formname: </label><input type='".$fftype[$formtype]."' name='$rawname-".$formname."-$section' id='$rawname-".$formname."-$section' value='".$formval."' class='xeditable'><br/>\n";
            }
            $ret.="<button id='removesection-$rawname-$section' onClick='fop2_removeSection(this.id); return false;'>"._('Remove Section')."</button>\n";
            $ret.="</fieldset>\n";
        }
    }

    $ret.="</form>\n";
    if(count($multiform)>0) {
        $ret.="<button onClick='fop2_addConfig(\"$rawname\",\"plugin_$rawname\"); return false;'>"._('Add Section')."</button>";
    }
    $ret.="<button onClick='fop2_saveConfig(\"$rawname\"); return false;'>"._('Save')."</button>";
    return $ret;
}

function ping($host,$timeout=1) {
    /* ICMP ping packet with a pre-calculated checksum */
    $ip = gethostbyname($host);

    $output = array();
    $com = 'ping -n -w ' . $timeout . ' -c 1 ' . $ip;
    
    $exitcode = 0;

    exec($com, $output, $exitcode);

    if ($exitcode == 0 || $exitcode == 1)
    { 
        foreach($output as $cline)
        {
            if (strpos($cline, ' bytes from ') !== FALSE)
            {
                $out = (int)ceil(floatval(substr($cline, strpos($cline, 'time=') + 5)));
                return $out;
            }
        }
    }
    
    return 1000;
}

function fop2_downloadPlugin($itemid, $mirror) {
    global $db, $amp_conf;
    $itemid = preg_replace("/[^A-Za-z0-9\._-]/","",$itemid);
    $fn = "http://$mirror/plugins/$itemid.tgz";
    $pluginjs = @ file_get_contents($fn);
    $tgzfile = substr(escapeshellarg($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$itemid.tgz"),1,-1);
    $fp = fopen($tgzfile,"w");
    fputs($fp,$pluginjs);
    fclose($fp);
    exec("tar zxf ".$tgzfile." -C ".escapeshellarg($amp_conf['AMPWEBROOT'].'/admin/modules/fop2admin/plugins/'), $output, $exitcode);
    unlink($tgzfile);
    if($exitcode==0) {
        // Insertar en la base de datos el plugin
        list ( $rawname, $nada) = preg_split("/-/",$itemid,2);
        $infoxml = substr(escapeshellarg($amp_conf['AMPWEBROOT']."/admin/modules/fop2admin/plugins/$rawname/plugin.xml"),1,-1);
        $pluginxml = file_get_contents($infoxml);
        $xml = new xml2Array($pluginxml);
        $xmlarray = $xml->parseAdvanced($pluginxml);
        $data = $xmlarray['plugin'];

        $results = sql( "REPLACE INTO fop2plugins (rawname, name, version, description) values ('".$db->escapeSimple($data['rawname'])."','".$db->escapeSimple($data['name'])."','".$db->escapeSimple($data['version'])."','".$db->escapeSimple($data['description'])."') ");
    } else {
         echo "Error extracting plugin archive ($exitcode)<br>";
    }
    needreload();
}

?>
